Global("wt", {
	Buttons = {{},{}},
	ButtonInfo = mainForm:GetChildUnchecked("ButtonM", false),
	ButtonElite = nil,		--"E"
	ButtonSearch = nil,		--"S"
	Tooltip = mainForm:GetChildUnchecked("WTC", false),
	PanelUnit = mainForm:GetChildUnchecked("PanelUnit", false),
	LineEdit = nil,
	AT = {{},{}}
})

function wt:Attach2D (id,num)
--num == 1(Search) or 2(Crown)
num = num ~= 1 and 2 or 1
if self.AT[num].id and object.IsExist(self.AT[num].id) then
	object.DetachWidget2D(self.AT[num].id)
end
if id == avatar.GetTarget() then return end
object.AttachWidget2D(id, self.AT[num].wdt, num == 1 and ATTACHED_OBJECT_POS_CENTER or ATTACHED_OBJECT_POS_UP)
self.AT[num].id = id
--self.AT[num].wdt:FinishResizeEffect()
self.AT[num].wdt:PlayResizeEffect( self.AT[num].p1, self.AT[num].p2, 3e3, EA_SYMMETRIC_FLASH )
end

function wt:TChAttach ()
if not self.AT[1].id and not self.AT[2].id then return end
--num == 1(Search) or 2(Crown)
for i=1, 2 do
	if self.AT[i].id and self.AT[i].id == avatar.GetTarget() then
		object.DetachWidget2D(self.AT[i].id)
		self.AT[i].wdt:Show(false)
	elseif RD.obj[5-i].id and object.IsExist(RD.obj[5-i].id) and RD.obj[5-i].id ~= avatar.GetTarget() then
		self:Attach2D (RD.obj[5-i].id,i)
		self.AT[i].id = RD.obj[5-i].id
	end
end
end

function wt:CreateWidgets()
--units
local x, y, pos, wtButDesc
pos = self.PanelUnit:GetPlacementPlain()
if Sets.Place == "L" then
	y = widgetsSystem:GetPosConverterParams().fullVirtualSizeY - Sets.Top - Sets.Bottom
	pos.sizeY, pos.sizeX, pos.posY, pos.posX = y, 24, Sets.Top, 0
else
	y = widgetsSystem:GetPosConverterParams().fullVirtualSizeX - Sets.Top - Sets.Bottom
	pos.sizeY, pos.sizeX, pos.posY, pos.posX = 24, y, 0, Sets.Top
end
self.PanelUnit:SetPlacementPlain(pos)
y = (y - 24) / 24
RD.maxTbl[1] = math.floor(y/2)
RD.maxTbl[2] = math.floor(y/2)
Sets.Direct = Sets.Direct == "T>B" and 1 or -1

x,y = 1,1
repeat
	y = 1
	if (x==1) and (y==1) then
		self.Buttons[1][1] = self.PanelUnit:GetChildUnchecked("ButtonC", false)
		pos = self.Buttons[1][1]:GetPlacementPlain()
		wtButDesc = self.Buttons[1][1]:GetWidgetDesc()
	end
	repeat
		self.Buttons[x][y] = mainForm:CreateWidgetByDesc(wtButDesc)
		if Sets.Place == "L" then
			pos.posY = 24*(RD.maxTbl[1] + Sets.Direct*(x>1 and y or (-y)))
		else
			pos.posX = 24*(RD.maxTbl[1] + Sets.Direct*(x>1 and y or (-y)))
		end
		self.PanelUnit:AddChild(self.Buttons[x][y])
		self.Buttons[x][y]:SetPlacementPlain(pos)
		self.Buttons[x][y]:SetName("U_"..tostring(y))
		y = y + 1
	until y > RD.maxTbl[x]
	x = x + 1
until x>2
--Elite button
self.ButtonElite = mainForm:CreateWidgetByDesc(wtButDesc)
pos.posX, pos.posY = 0, 24
self.ButtonElite:SetPlacementPlain(pos)
self.ButtonElite:SetName("E_0")
self.ButtonElite:SetBackgroundTexture(common.GetAddonRelatedTexture("ELITE"))
--Search button
self.ButtonSearch = mainForm:CreateWidgetByDesc(wtButDesc)
if Sets.Place == "L" then
	pos.posY, pos.posX = 24*RD.maxTbl[1], 0
else
	pos.posY, pos.posX = 0, 24*RD.maxTbl[1]
end
self.ButtonSearch:SetPlacementPlain(pos)
self.PanelUnit:AddChild(self.ButtonSearch)
self.ButtonSearch:SetName("S_sss")
self.ButtonSearch:SetBackgroundTexture(common.GetAddonRelatedTexture("SEARCH"))
self.ButtonSearch:SetBackgroundColor(sColor[8])
self.ButtonSearch:Show(true)
--Attach2D
wtButDesc = mainForm:GetChildUnchecked("Mark", false):GetWidgetDesc()
for i=1, 2 do
	self.AT[i].wdt = mainForm:CreateWidgetByDesc(wtButDesc)
	self.AT[i].wdt:SetBackgroundColor(sColor[13])
	self.AT[i].wdt:SetForegroundColor(sColor[14])
	self.AT[i].wdt:Show(false)
	self.AT[i].p1, self.AT[i].p2 = mainForm:GetChildUnchecked("Mark", false):GetPlacementPlain(), {}
	--for v,t in pairs(self.AT[i].p1) do self.AT[i].p2.v = t end
	self.AT[i].p1.sizeX, self.AT[i].p1.sizeY = i*32, i*32
	--self.AT[i].p1.sizeX, self.AT[i].p1.sizeY = 64, 64
	self.AT[i].p2.sizeX = self.AT[i].p1.sizeX*2
	self.AT[i].p2.sizeY = self.AT[i].p2.sizeX
end
self.AT[1].wdt:SetBackgroundTexture(common.GetAddonRelatedTexture("MARKSB"))
self.AT[2].wdt:SetBackgroundTexture(common.GetAddonRelatedTexture("MARKCB"))
self.AT[1].wdt:SetForegroundTexture(common.GetAddonRelatedTexture("MARKSF"))
self.AT[2].wdt:SetForegroundTexture(common.GetAddonRelatedTexture("MARKCF"))
--Editline
self.LineEdit = mainForm:GetChildUnchecked("WEL", false)
x = self.LineEdit:GetPlacementPlain()
if Sets.Place == "L" then
	x.posX = pos.posX + pos.sizeX
	x.posY = Sets.Top + pos.posY - x.sizeY
else
	x.posY = pos.posY + pos.sizeY
	x.posX = Sets.Top + pos.posX - x.sizeX
end
self.LineEdit:SetPlacementPlain(x)
--Tooltip
self.Tooltip:Show(false)
end

function wt:myTooltip(wdt)
if wdt then
	local pos,pos2 = wdt:GetPlacementPlain(), self.Tooltip:GetPlacementPlain()
	if Sets.Place == "L" then
		pos2.posX = 2*pos.sizeX + pos.posX
		pos2.posY = (string.find(wdt:GetName(),"E_") and 0 or Sets.Top) + pos.posY
	else
		pos2.posY = (string.find(wdt:GetName(),"E_") and 0 or 2*pos.sizeY) + pos.posY
		pos2.posX = (string.find(wdt:GetName(),"E_") and 2*pos.sizeX or Sets.Top) + pos.posX
	end
	self.Tooltip:SetPlacementPlain(pos2)
end
self.Tooltip:Show(RD:SetBlock(wdt~=nil))
end

function wt:Update()
--Units
--common.LogInfo(common.GetAddonName(),"wt:Update()")
self.ButtonInfo:SetVal("friends",common.FormatInt(RD:count(1),"%02d"))
self.ButtonInfo:SetVal("enemies",common.FormatInt(RD:count(2),"%02d"))
for i=1,2 do
		for v,t in self.Buttons[i] do
			t:Show(RD.obj[i][v]~=nil)
			if RD.obj[i][v] then
				t:SetName("U_"..tostring(RD.obj[i][v].id))
				t:ClearValues()
				if RD.obj[i][v].colorText > 0 then
					t:SetVal("rlevel",common.FormatInt(RD.obj[i][v].level,"%n"))
				else
					t:SetVal("wlevel",common.FormatInt(RD.obj[i][v].level,"%n"))
				end
				t:SetBackgroundTexture(common.GetAddonRelatedTexture(RD.obj[i][v].className))
				t:SetBackgroundColor(sColor[RD.obj[i][v].color])
			end
		end
end
--Elite
if RD.obj[3].id and object.IsExist(RD.obj[3].id) then
	if self.ButtonElite:GetName()~= ("E_"..tostring(RD.obj[3].id)) then
		self.ButtonElite:SetName("E_"..tostring(RD.obj[3].id))
		self.ButtonElite:SetVal("wlevel",common.FormatInt(RD.obj[3].level,"%n"))
		self.ButtonElite:SetBackgroundColor(sColor[RD.obj[3].color])
		if RD.obj[3].id~=RD.obj[4].id then
			self:Attach2D(RD.obj[3].id,2)
		else
			
		end
	end
elseif self.AT[2].id and object.IsExist(self.AT[2].id) then
	object.DetachWidget2D(self.AT[2].id)
	self.AT[2].id = nil
	self.AT[2].wdt:Show(false)
end

self.ButtonElite:Show(RD.obj[3].id~=nil)
--Find
self.ButtonSearch:SetBackgroundColor(sColor[RD.obj[4].id and 9 or 8])
if RD.obj[4].id and object.IsExist(RD.obj[4].id) then
	if self.ButtonSearch:GetName()~= ("S_"..tostring(RD.obj[4].id)) then
		self.ButtonSearch:SetName("S_"..tostring(RD.obj[4].id))
		if RD.obj[3].id~=RD.obj[4].id then
			self:Attach2D(RD.obj[4].id,1)
		else
			
		end
	end
elseif self.AT[1].id and object.IsExist(self.AT[1].id) then
	object.DetachWidget2D(self.AT[1].id)
	self.AT[1].id = nil
	self.AT[1].wdt:Show(false)
end
end

function wt:SetTTH(num)
local pos = self.Tooltip:GetPlacementPlain()
pos.sizeY = num
self.Tooltip:SetPlacementPlain(pos)
end

function wt:SetMyParents()
--Set parent of my Mark (min priority)
local Par = stateMainForm:GetChildUnchecked("MainAddonMainForm",false)
if Par then
	Par:AddChild(self.AT[1].wdt)
	Par:AddChild(self.AT[2].wdt)
end
--common.LogInfo(common.GetAddonName(),"AT.wdt Parent:", Par:GetName())
--Set parent of my Form (middle priority)
Par = stateMainForm:GetChildUnchecked("ContextBag",false)
if Par then
	Par:AddChild(mainForm)
end
--common.LogInfo(common.GetAddonName(),"mainForm Parent:", Par:GetName())
--Set parent of my Tooltip (max priority)
Par = stateMainForm:GetChildUnchecked("ContextTooltip",false)
if Par then
	Par:AddChild(self.Tooltip)
else
	Par = stateMainForm:GetChildUnchecked("Tooltip",true)
	if Par then Par:GetParent():AddChild(self.Tooltip) end
end
--common.LogInfo(common.GetAddonName(),"Tooltip Parent:", Par:GetName())
end

function wt:EnableUP(flg)
if flg then
	self.ButtonInfo:SetVal("friends",common.FormatInt(RD:count(1),"%02d"))
	self.ButtonInfo:SetVal("enemies",common.FormatInt(RD:count(2),"%02d"))
	RegEv(EVRe)
	--common.RegisterEventHandler(EVRe.EVENT_SECOND_TIMER,"EVENT_SECOND_TIMER")
else
	UnRegEv(EVRe)
	--common.UnRegisterEventHandler(EVRe.EVENT_SECOND_TIMER,"EVENT_SECOND_TIMER")
	self.ButtonInfo:SetVal("friends",userMods.ToWString("--"))
	self.ButtonInfo:SetVal("enemies",userMods.ToWString("--"))
	for i=1,2 do
		if self.AT[i].id then
			object.DetachWidget2D(self.AT[i].id)
			self.AT[i].wdt:Show(false)
		end
	end
end
self.PanelUnit:Show(flg)
end

function wt:Init()
self:CreateWidgets()
self:SetMyParents()
end

---=====----
function SetHPbar(HPpers)
local ttp, pos = wt.Tooltip:GetChildUnchecked("PanelHP", false)
if not HPpers then
	ttp:Show(false)
	return
end
pos = ttp:GetPlacementPlain()
pos.alignX = 0
pos.sizeX = HPpers * (ttp:GetParent():GetPlacementPlain().sizeX - 20) / 100
ttp:SetPlacementPlain(pos)
ttp:SetBackgroundColor(sColor[HPpers<25 and 10 or (HPpers>70 and 11 or 12)])
ttp:Show(true)
end

function Repaint()
--if RD:Update() then wt:Update() end
local mCor = coroutine.create(function () if RD:Update() then wt:Update() end end)
coroutine.resume(mCor)
end

function GetTextLocalized (strText)
return Lc[Sets.Lang][strText] and userMods.ToWString(Lc[Sets.Lang][strText]) or userMods.ToWString(strText)
end

function PrepareTT (w)
local id = tonumber(string.sub(w:GetName(),3))
--id = avatar.GetId()
local ttp, vT, HH, tmp, tip = wt.Tooltip:GetChildUnchecked("Panel",false), common.CreateValuedText(), 80
if string.find(w:GetName(),"U_") then	--Player info
	if not object.IsExist(id) then return end
	tmp = {
		Class = unit.GetClass(id),
		FI = unit.GetFairyInfo(id),
		Guild = unit.GetGuildName(id),
		HPP = unit.GetHealthPercentage(id),
		Level = common.FormatInt(unit.GetLevel(id),"%d"),
		Name = object.GetName(id),
		Sex = unit.GetSex(id)
	}
--Icon
	ttp:SetBackgroundColor(classColor[tmp.Class.className])
	ttp:SetBackgroundTexture(common.GetAddonRelatedTexture(tmp.Class.className))
	--ttp:SetForegroundTexture(common.GetAddonRelatedTexture(tmp.Class.className))
	ttp:Show(true)
	SetHPbar(tmp.HPP)
--Name
	wt.Tooltip:RemoveItems()
	vT:SetFormat(userMods.ToWString("<header fontsize='18'>`     <r name='text'/><br/></header>"))
	vT:SetVal("text", tmp.Name)
	wt.Tooltip:PushBackValuedText(vT)
--Info
	vT:SetFormat(userMods.ToWString("<html fontsize='14'><r name='race'/>, <r name='class'/>, <r name='nlevel'/> <r name='level'/></html>"))
	vT:SetVal("race", tmp.Sex.raceSexName)
	vT:SetVal("class", tmp.Class.raceClassName)
	vT:SetVal("level", tmp.Level)
	vT:SetVal("nlevel", GetTextLocalized("Level"))
	wt.Tooltip:PushBackValuedText(vT)
--Guild
	if string.len(userMods.FromWString(tmp.Guild)) > 0 then
		vT:SetFormat( userMods.ToWString("<html fontsize='16' color = '0xf0f000f0'><r name='text'/></html>"))
		vT:SetVal( "text", tmp.Guild)
		wt.Tooltip:PushBackValuedText(vT)
		HH = HH + 24
	end
--Fairy Info
	if tmp.FI.isExist and Sets.SFairy then
		tip = tmp.FI.isHungry and "0xf0a0a0a0" or "0xf0f0f000"
		vT:SetFormat( userMods.ToWString("<html fontsize='14' color = '"..tip.."'><r name='text'/>. <r name='nrank'/> <r name='rank'/></html>"))
		vT:SetVal("text", tmp.FI.name)
		vT:SetVal("rank", common.FormatInt(tmp.FI.rank,"%d"))
		vT:SetVal("nrank", GetTextLocalized("Rank"))
		wt.Tooltip:PushBackValuedText(vT)
		vT:SetFormat( userMods.ToWString("<html fontsize='14'><r name='stat'/> +<r name='bonus'/>, <r name='nlevel'/> <r name='level'/></html>"))
		vT:SetVal("nlevel", GetTextLocalized("Level"))
		vT:SetVal("level", common.FormatInt(tmp.FI.level,"%d"))
		vT:SetVal("stat", GetTextLocalized(IS[tmp.FI.bonusStat]))
		vT:SetVal("bonus", common.FormatInt(tmp.FI.bonusStatValue,"%d"))
		wt.Tooltip:PushBackValuedText(vT)
		HH = HH + 48
	end
	wt:SetTTH(HH)
	return true
elseif string.find(w:GetName(),"S_") then	--Find object info
--Icon
	ttp:SetBackgroundColor(sColor[RD.obj[4].id and 9 or 8])
	ttp:SetBackgroundTexture(common.GetAddonRelatedTexture("SEARCH"))
	ttp:Show(true)
	SetHPbar()
--Header
	wt.Tooltip:RemoveItems()
	vT:SetFormat(userMods.ToWString("<header alignx='center' fontsize='16'><r name='text'/><br/></header>"))
	vT:SetVal("text", GetTextLocalized("TTIOT"))
	wt.Tooltip:PushBackValuedText(vT)
--Search string
	vT:SetFormat(userMods.ToWString("<html fontsize='14'><r name='text'/> :</html>"))
	vT:SetVal("text", GetTextLocalized("Search"))
	wt.Tooltip:PushBackValuedText(vT)
	vT:SetFormat(userMods.ToWString("<html color = '0xf0f000f0' fontsize='16'><r name='text'/></html>"))
	vT:SetVal("text", RD.blockscan and GetTextLocalized("None") or RD.searched)
	wt.Tooltip:PushBackValuedText(vT)
	HH = HH + 10
--Find object string
	if RD.obj[4].id then
		vT:SetFormat(userMods.ToWString("<html fontsize='14'><r name='text'/> :</html>"))
		vT:SetVal("text", GetTextLocalized("Find"))
		wt.Tooltip:PushBackValuedText(vT)
		vT:SetFormat(userMods.ToWString("<html color = '0xf0f000f0' fontsize='16'><r name='text'/></html>"))
		vT:SetVal("text", RD.obj[4].name)
		wt.Tooltip:PushBackValuedText(vT)
		HH = HH + 44
	end
	wt:SetTTH(HH)
	return true
elseif string.find(w:GetName(),"E_") then	--Elite info
	if not object.IsExist(id) then return end
	tmp = {
		HPP = unit.GetHealthPercentage(id),
		Level = common.FormatInt(unit.GetLevel(id),"%d"),
		Name = object.GetName(id),
	}
--Icon
	ttp:SetBackgroundColor(sColor[RD.obj[3].color])
	ttp:SetBackgroundTexture(common.GetAddonRelatedTexture("ELITE"))
	ttp:Show(true)
	SetHPbar(tmp.HPP)
--Name
	wt.Tooltip:RemoveItems()
	vT:SetFormat(userMods.ToWString("<header fontsize='16'>'     <r name='text'/><br/></header>"))
	vT:SetVal("text", tmp.Name)
	wt.Tooltip:PushBackValuedText(vT)
--Info
	vT:SetFormat(userMods.ToWString("<html fontsize='14'><r name='level'/> <r name='nlevel'/></html>"))
	vT:SetVal("level", tmp.Level)
	vT:SetVal("nlevel", GetTextLocalized("Level"))
	wt.Tooltip:PushBackValuedText(vT)
	wt:SetTTH(HH)
	return true
end
end

function SetAddonLoc (loc)
if loc == "auto" then
	for _,mb in cartographer.GetMapBlocks() do
		for l,t in {rus = "\209\226\255\242\224\255 \199\229\236\235\255", eng = "Holy Land", ger = "Heiliges Land", fra = "Terre Sacr\233e"} do
			if userMods.FromWString( cartographer.GetMapBlockInfo(mb).name ) == t then
				return SetAddonLoc(l)
			end
		end
	end
else
	for v,t in Lc do
		if t.LShort and t.LShort == loc then return v end
	end
end
return 1
end

function Init()
Reg(EVRe)
if avatar.IsExist () then EVRe.EVENT_AVATAR_CREATED() end
end

Init()