Global("EVRe", {})

Global("qpq", nil)

function RegEv (ER)
for v,t in pairs(ER) do
	if string.find(v, "[A-Z]+T_+[A-Z]") then common.RegisterEventHandler(t,v) end
end
end

function RegERk (ER)
for v,t in pairs(ER) do
	if not string.find(v, "[A-Z]+T_+[A-Z]") then common.RegisterReactionHandler(t,v) end
end
end

function UnRegEv (ER)
for v,t in pairs(ER) do
	if string.find(v, "[A-Z]+T_+[A-Z]") then common.UnRegisterEventHandler(t,v) end
end
end

function UnRegERk (ER)
for v,t in pairs(ER) do
	if not string.find(v, "[A-Z]+T_+[A-Z]") then common.UnRegisterReactionHandler(t,v) end
end
end

function Reg (ER)
RegEv(ER)
RegERk(ER)
end

function UnReg (ER)
UnRegEv(ER)
UnRegERk(ER)
end

----- EVENTS -----
EVRe["SCRIPT_ADDON_INFO_REQUEST"] = function(params)
if params.target == common.GetAddonName() then
	userMods.SendEvent( "SCRIPT_ADDON_INFO_RESPONSE", {
		sender = params.target,
		desc = RD.ver[1].." v."..tostring(RD.ver[2]).." ["..RD.ver[3].."]"
		--showDNDButton = false,
		--showHideButton  = false,
		--showSettingsButton = false
		--addonsBlocked = {}
	})
end
end

EVRe["U_EVENT_ADDON_MEM_USAGE_REQUEST"] = function(params)
userMods.SendEvent( "U_EVENT_ADDON_MEM_USAGE_RESPONSE", {sender = common.GetAddonName(), memUsage = gcinfo()})
end

EVRe["EVENT_AVATAR_CREATED"] = function(params)
RD:Init()
wt:Init()
--common.LogInfo(common.GetAddonName(),"0 len ", tostring(table.getn(Lc)))
Sets.Lang = SetAddonLoc(Sets.Lang)
common.LogInfo(common.GetAddonName(),"Init")
end

EVRe["EVENT_UNIT_LEVEL_CHANGED"] = function(params)
RD:DetectCh ()
end

EVRe["EVENT_UNIT_DEAD_CHANGED"] = function(params)
RD:DetectCh (params)
end

EVRe["EVENT_UNITS_CHANGED"] = function(params)
RD:DetectCh (params)
end

EVRe["EVENT_DEVICES_CHANGED"] = function(params)
RD:ObjSearch (params.spawned)
end

EVRe["EVENT_AVATAR_SECONDARY_TARGET_CHANGED"] = function(params)
wt:TChAttach ()
end

EVRe["EVENT_SECOND_TIMER"] = function(params)
Repaint()
end

--[[EVRe["EVENT_INSPECT_STARTED"] = function(params)
if not qpq then return end
common.LogInfo(common.GetAddonName(),object.GetName(qpq))
	for v, t in unit.GetEquipmentItemIds(qpq,ITEM_CONT_EQUIPMENT) do
		if avatar.GetItemInfo(t).runeInfo then
			common.LogInfo(common.GetAddonName(),tostring(avatar.GetItemInfo(t).runeInfo.runeLevel))
			--common.LogInfo(common.GetAddonName(),"offensiveBonus ",tostring(avatar.GetItemInfo(t).runeInfo.offensiveBonus))
			--common.LogInfo(common.GetAddonName(),"defensiveBonus", tostring(avatar.GetItemInfo(t).runeInfo.defensiveBonus))
		end
		
	end
	
	
	avatar.EndInspect()
	avatar.UnselectTarget()
	common.LogInfo(common.GetAddonName(),"avatar.EndInspect()")

qpq = nil


end]]


---- Reactions ----
EVRe["ButtonC_clk"] = function(reaction)
avatar.SelectTarget(tonumber(string.sub(reaction.widget:GetName(),3)))
end

EVRe["ButtonC_rclk"] = function(reaction)
local id, itms
if string.find(reaction.widget:GetName(),"S_") then
	if wt.LineEdit:IsVisible()then
		wt.LineEdit:Show(false)
	else
		wt.LineEdit:SetText(RD.searched)
		wt.LineEdit:Show(true)
		wt.LineEdit:SetFocus(true)
	end
--[[elseif string.find(reaction.widget:GetName(),"U_") then
	common.LogInfo(common.GetAddonName(),"avatar.StartInspect()")
	qpq = tonumber(string.sub(reaction.widget:GetName(),3))
	avatar.SelectTarget(qpq)
	avatar.StartInspect()]]
end
end

EVRe["ButtonC_pnt"] = function(reaction)
if reaction.active and PrepareTT(reaction.widget) then
	wt:myTooltip(reaction.widget)
else wt:myTooltip() end
end

EVRe["ButtonM_clk"] = function(reaction)
wt:EnableUP(not wt.PanelUnit:IsVisible())

--[[local em
for v,t in avatar.GetEmotes() do
	em = avatar.GetEmoteInfo(t)
	if em then
		common.LogInfo(common.GetAddonName(),"name ",em.name)
		common.LogInfo(common.GetAddonName(),"...hasMood ",tostring(em.hasMood))
		common.LogInfo(common.GetAddonName(),"...description ", em.description)
		common.LogInfo(common.GetAddonName(),"...sysName ", em.sysName)
		if em.sysName == "lonelyMood" then avatar.RunEmote(t) end
	end
end]]

end

EVRe["ButtonM_rclk"] = function(reaction)
--wt:EnableUP(not wt.PanelUnit:IsVisible())
end

EVRe["rEn"] = function(reaction)
local sch = reaction.widget:GetText()
if (string.len(userMods.FromWString(sch)) > 3) or (string.len(userMods.FromWString(sch)) < 1) then
	RD.searched = sch
	--common.LogInfo(common.GetAddonName(),"reaction ",sch)
	wt.LineEdit:Show(false)
	RD:Init()
end
end

EVRe["rESC"] = function(reaction)
wt.LineEdit:Show(false)
end